require "import"
import "android.widget.*"
import "android.view.*"
import "android.app.*"
import "java.util.*"

local activity = activity
local textView

function onCreate(savedInstanceState)
    activity.setTitle("Kalender Masehi & Hijriah by Mr. Zain")
    local layout = LinearLayout(activity)
    layout.setOrientation(1)
    
    local button = Button(activity)
    button.setText("Open Calendar")
    button.setOnClickListener{
        onClick = function(v)
            showDatePickerDialog()
        end
    }
    layout.addView(button)

    textView = TextView(activity)
    textView.setTextSize(16)
    layout.addView(textView)
    
    activity.setContentView(layout)
end

function showDatePickerDialog()
    local calendar = Calendar.getInstance()
    local year = calendar.get(Calendar.YEAR)
    local month = calendar.get(Calendar.MONTH)
    local day = calendar.get(Calendar.DAY_OF_MONTH)
    
    local datePickerDialog = DatePickerDialog(
        activity,
        DatePickerDialog.OnDateSetListener{
            onDateSet = function(view, year, monthOfYear, dayOfMonth)
                local selectedDate = string.format("Selected date (Gregorian): %d-%02d-%02d", year, monthOfYear + 1, dayOfMonth)
                
                -- Konversi ke Hijriyah
                local hijriDate = convertToHijri(year, monthOfYear + 1, dayOfMonth)
                
                textView.setText(selectedDate .. "\n" .. hijriDate)
            end
        },
        year, month, day
    )
    datePickerDialog.show()
end

function convertToHijri(gregorianYear, gregorianMonth, gregorianDay)
    local jd = (1461 * (gregorianYear + 4800 + (gregorianMonth - 14) // 12)) // 4 +
               (367 * (gregorianMonth - 2 - 12 * ((gregorianMonth - 14) // 12))) // 12 -
               (3 * ((gregorianYear + 4900 + (gregorianMonth - 14) // 12) // 100)) // 4 +
               gregorianDay - 32075

    local l = jd - 1948440 + 10632
    local n = (l - 1) // 10631
    l = l - 10631 * n + 354
    local j = ((10985 - l) // 5316) * ((50 * l) // 17719) + (l // 5670) * ((43 * l) // 15238)
    l = l - ((30 - j) // 15) * ((17719 * j) // 50) - ((j // 16) * ((15238 * j) // 43)) + 29
    local hijriMonth = (24 * l) // 709
    local hijriDay = l - (709 * hijriMonth) // 24
    local hijriYear = 30 * n + j - 30

    local hijriMonthName = {"Muharram", "Safar", "Rabi' al-Awwal", "Rabi' al-Thani", "Jumada al-Awwal", "Jumada al-Thani", "Rajab", "Sha'ban", "Ramadan", "Shawwal", "Dhu al-Qi'dah", "Dhu al-Hijjah"}
    local hijriMonthString = hijriMonthName[hijriMonth]
    
    return string.format("Selected date (Hijri): %d-%s-%02d", hijriYear, hijriMonthString, hijriDay)
end